﻿

namespace Validation
{
    using System;
    using System.Collections.Generic;
    using System.Globalization;
    using System.Linq;
    using System.Text;
    using System.Threading;
    using System.Threading.Tasks;
    using System.Windows.Controls;

    class DoubleRangeValidationRule : ValidationRule
    {
        private DoubleRangeModel m_DoubleRangeModel;

        public DoubleRangeValidationRule()
        {
        }

        public void setDoubleRangeModel(DoubleRangeModel vm)
        {
            m_DoubleRangeModel = vm;
        }

        public override ValidationResult Validate(object value, System.Globalization.CultureInfo cultureInfo)
        {
            if ( m_DoubleRangeModel == null )
            {
                return new ValidationResult(false, "No DoubleRangeModel is set!");
            }

            Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture("en-US");

            string inputString = value as string;

            if (null == inputString)
            {
                return new ValidationResult(false, "String conversion error.");
            }

            double inputNumber;

            if (false == double.TryParse(inputString, out inputNumber) 
                || inputNumber < m_DoubleRangeModel.Min || inputNumber > m_DoubleRangeModel.Max)
            {
                return new ValidationResult(false,
                                            string.Format("Please enter a number between {0} and {1}.",
                                            m_DoubleRangeModel.Min, m_DoubleRangeModel.Max));
            }

            return ValidationResult.ValidResult;
        }
    }
}
