﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Validation
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private DoubleRangeModel m_DoubleRangeModel;

        private DoubleRangeValidationRule m_DoubleRangeValidationRule;

        private AxisSettingsModel m_XAxisSettingsModel;

        private AxisDisplayRangeValidationRule m_AxisDisplayMaxRangeValidationRule;

        private AxisDisplayRangeValidationRule m_AxisDisplayMinRangeValidationRule;

        public MainWindow()
        {
            InitializeComponent();

            m_DoubleRangeModel = this.Resources["DoubleRangeModel"] as DoubleRangeModel;

            m_DoubleRangeModel.CurrentValue = 210.5;

            m_DoubleRangeModel.Min = 100.0;

            m_DoubleRangeModel.Max = 300.0;

            m_DoubleRangeValidationRule = this.Resources["DoubleRangeValidationRule"] as DoubleRangeValidationRule;

            m_DoubleRangeValidationRule.setDoubleRangeModel(m_DoubleRangeModel);

            /// ***************************************************************************************************
            ///

            m_XAxisSettingsModel = this.Resources["XAxisSettingsModel"] as AxisSettingsModel;

            m_XAxisSettingsModel.ActualMaximumValue = 850;

            m_XAxisSettingsModel.ActualMinimumValue = 150;

            m_AxisDisplayMaxRangeValidationRule = this.Resources["AxisDisplayMaxRangeValidationRule"] as AxisDisplayRangeValidationRule;

            m_AxisDisplayMaxRangeValidationRule.setAxisSettingsModel(m_XAxisSettingsModel);

            m_AxisDisplayMaxRangeValidationRule.setCheckDisplayRange(AxisDisplayRangeValidationRule.CheckDisplayRange.DisplayRangeMax);

            m_AxisDisplayMinRangeValidationRule = this.Resources["AxisDisplayMinRangeValidationRule"] as AxisDisplayRangeValidationRule;

            m_AxisDisplayMinRangeValidationRule.setAxisSettingsModel(m_XAxisSettingsModel);

            m_AxisDisplayMinRangeValidationRule.setCheckDisplayRange(AxisDisplayRangeValidationRule.CheckDisplayRange.DisplayRangeMin);

        }

        private void ValueTextBox_KeyDown_1(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Tab || e.Key == Key.Enter)
            {
                BindingExpression b = ValueTextBox.GetBindingExpression(TextBox.TextProperty);
                if (b.ValidateWithoutUpdate())
                    b.UpdateSource();
            }
        }

        private void numericEditorXMax_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Tab || e.Key == Key.Enter)
            {
                int i = 0;
            }
        }

        private void XDisplayMaxDoubleUpDown_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (e.NewValue == null)
            {
                m_XAxisSettingsModel.ActualMaximumDisplayValue = (double)e.OldValue;

                XMaxDisplayDoubleUpDown.Value = (double)e.OldValue;
            }
        }

        private void XMinDisplayDoubleUpdown_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (e.NewValue == null)
            {
                m_XAxisSettingsModel.ActualMinimumDisplayValue = (double)e.OldValue;

                XDisplayMinDoubleUpDown.Value = (double)e.OldValue;
            }

        }

        private void XMaxDisplayDoubleUpDown_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Tab || e.Key == Key.Enter)
            {
                double currentValue = (double)XMaxDisplayDoubleUpDown.Value;
            }
        }
    }
}
